#!/usr/bin/perl

##### 'Clonescan' script developed by Linux-Development on irc.quakenet.org ( #Linux-Dev ) Version 1.3.0
##### This program is free software; you can redistribute it and/or modify
##### it under the terms of the GNU General Public License as published by
##### the Free Software Foundation; either version 2 of the License, or
##### (at your option) any later version.
##### This program is distributed in the hope that it will be useful,
##### but WITHOUT ANY WARRANTY; without even the implied warranty of
##### MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##### GNU General Public License for more details.
##### You should have received a copy of the GNU General Public License
##### along with this program; if not, write to the Free Software
##### Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

### Xchat registers and hooks.

Xchat::register("irc.quakenet.org:6667 #Linux-Dev Clonescanner for XChat", "1.3.0", "This is the clonescanner from Linux-Dev");
Xchat::hook_print("Join", "on_join");
Xchat::hook_command("clone", "cmdScanforclones");

### Perlmodules.

use strict;
use warnings;

sub on_join {
	my @users = Xchat::get_list('users');
	my $context = Xchat::get_context();
	my $alreadyPrintedOne = 0;
	my @splitted = split('@', $_[0][2]);
	my $joinedUsersHost = $splitted[1];
	my $clonesOf = $_[0][0];
	unless(!defined $joinedUsersHost){
		foreach my $aUser (@users){
			if($aUser->{'nick'} ne $_[0][0]){
				if(defined($aUser->{'host'})){
					my @splitted = split('@', $aUser->{'host'});
					my $aUsersHost = $splitted[1];
					if($aUsersHost eq $joinedUsersHost){
						my $clone = $aUser->{'nick'};
						if($alreadyPrintedOne != 1){
							Xchat::hook_timer(0, sub {
								my $oldContext = Xchat::get_context();
								Xchat::set_context("$context");
								Xchat::print("..:: Clone(s) of $clonesOf are: ::..");
								Xchat::set_context("$oldContext");
								return Xchat::REMOVE;
							});
							$alreadyPrintedOne = 1;
						}
						Xchat::hook_timer(0, sub {
							my $oldContext = Xchat::get_context();
							Xchat::set_context("$context");
							Xchat::print($clone);
							Xchat::set_context("$oldContext");
							return Xchat::REMOVE;
						});
					}
				}
			}
		}
	}
	return 0;
}

sub cmdScanforclones {
	my $clonescount = my $users = my $clonehosts = my $hasClones = 0;
	my(%usedNicks, $usedNicks);
	my $channel = $_[0][1];
	if(!$channel){
		$channel = Xchat::get_info('channel');
	}
	my @Wert;
	my(%clones, %aUser, %secondUser);
	my($clones, $clone, $Schluessel);
	Xchat::set_context("$channel");
	my @users = Xchat::get_list('users');
	foreach my $aUser (@users){
		$users++;
		if(!defined($usedNicks->{$aUser->{'nick'}})){
			$usedNicks->{$aUser->{'nick'}} = 1;
			if(defined($aUser->{'host'})){
				my @splitted = split('@', $aUser->{'host'});
				my $aUsersHost = $splitted[1];
				foreach my $secondUser (@users){
					if(!defined($usedNicks->{$secondUser->{'nick'}})){
						if(defined($secondUser->{'host'})){
							@splitted = split('@', $secondUser->{'host'});
							my $secondUsersHost = $splitted[1];
							@{$clones->{$aUsersHost}}=();
							if($aUsersHost eq $secondUsersHost){
								$usedNicks->{$secondUser->{'nick'}} = 1;
								push(@{$clones{$aUsersHost}}, $secondUser->{'nick'});
								$hasClones = 1;
							}
						}
					}
				}
				if($hasClones == 1){
					push(@{$clones{$aUsersHost}}, $aUser->{'nick'});
					$clonehosts++;
				}
			}
			$hasClones = 0;
		}
	}
	Xchat::command("QUERY Clonescanner::$channel");
	Xchat::set_context("Clonescanner::$channel");
	Xchat::print("---------------------");
	while(($Schluessel, @Wert) = each(%clones)){
		Xchat::print("\cB$Schluessel:");
		foreach my $oneClone (@{$Wert[0]}){
			Xchat::print("$oneClone");
			$clonescount++;
		}
	}
	$users -= $clonescount;
	$users += $clonehosts;
	Xchat::print("\"$clonescount\" clone(s) on \"$clonehosts\" different clonehost(s), \"$users\" unique users in \"$channel\"");
	Xchat::print("---------------------");
	return 1;
}

#####
##### That's all, folks!
#####